forecast_GARCH_MLE_n <- function(est, fitted, steps = 1) {
	λ <- fitted[["lambda"]][length(fitted[["lambda"]])]
	α <- est$optim_vals[["α"]]
	β <- est$optim_vals[["β"]]
	ω <- est$optim_vals[["ω"]]

	if (length(steps) == 1) {
		pred <- rep(NA, steps)

		pred[1] <- ω + (β + α)*λ
		if (steps == 1) {
			return(pred)
		}

		for (i in 1:(steps-1)) {
			# Because ε is martingale difference sequence the expected value should be zero	
			pred[i+1] <- ω + (β + α)* pred[i]
		}
		return(pred)
	} else {
		output <- list()
		for (i in 1:length(steps)) {
			pred <- rep(NA, steps[i])
			pred[1] <- ω + (β + α)*λ
			if (steps[i] == 1) {
				output[[i]] <- pred
			} else {

				for (j in 1:(steps[i]-1)) {
					# Because ε is martingale difference sequence the expected value should be zero	
					pred[j+1] <- ω + (β + α)* pred[j]
				}
				output[[i]] <- pred
			}
		}
		return(output)
	}
}