forecast_rGARCH_multiple <- function(est, fitted, steps = 1, type = "", simulations = 100) {
	
	# Set the necessary parameters Lunde specification

	# rvs <- nrow(est$rv_params)
	# n <- length(est$optim_vals)
	# γ <- est$optim_vals[(n-rvs):(n-1)]

	# B = c(γ,1,γ)
	# A = est$optim_vals["β"] + γ %*% est$rv_params[,"φ"]
	# C = est$optim_vals["ω"] + γ %*% est$rv_params[,"ξ"]

	# # If no type set, defaulting to the standard forecasting.
	# z <- fitted[["z"]][length(fitted[["z"]])]
	# u <- fitted[["u"]][nrow(fitted[["u"]]),]

	# er <- c(z^2, z^2-1)
	# ε <- c(er%*%t(est$rv_params[,c("δ_1", "δ_2")]), t(er)%*%est$optim_vals[c("d1", "d2")], u)

	# pred <- rep(NA, max(steps))

	# pred[1] <- C + A*fitted[["lambda"]][length(fitted[["lambda"]])] + B%*%ε

	# if (max(steps) == 1) {
	# 	return(pred)
	# }

	# for (i in 1:(max(steps)-1)) {
	# 	# Because ε is martingale difference sequence the expected value should be zero	
	# 	pred[i+1] <- C + A*pred[i]
	# }
	# return(pred)

	# Hansen specification

	rvs <- nrow(est$rv_params)
	n <- length(est$optim_vals)
	γ <- est$optim_vals[(n-rvs):(n-1)]

	B = c(1,γ)
	A = est$optim_vals["β"]
	C = est$optim_vals["ω"]

	# If no type set, defaulting to the standard forecasting.
	z <- fitted[["z"]][length(fitted[["z"]])]
	u <- fitted[["u"]][nrow(fitted[["u"]]),]

	er <- c(z^2, z^2-1)
	ε <- c(t(er)%*%est$optim_vals[c("d1", "d2")], u)

	pred <- rep(NA, max(steps))

	pred[1] <- C + A*fitted[["lambda"]][length(fitted[["lambda"]])] + B%*%ε

	if (max(steps) == 1) {
		return(pred)
	}

	for (i in 1:(max(steps)-1)) {
		# Because ε is martingale difference sequence the expected value should be zero	
		pred[i+1] <- C + A*pred[i]
	}
	return(pred)
}

