#import <Rcpp.h>
using namespace Rcpp;

// [[Rcpp::export]]
List recursive_filter_GARCH_n(NumericVector params, NumericVector ret)
{
	int n = ret.size();
	double omega = params[0];
	double alp = params[1];
	double bet = params[2];

	std::vector<double> lambda_vals(n);
	std::vector<double> z_vals(n);

	lambda_vals[0] = params[3];
	z_vals[0] = ret[0]/sqrt(lambda_vals[0]);

	for (int i = 1; i < n; i++) {
	    lambda_vals[i]= omega + bet*lambda_vals[i-1] + alp*pow(ret[i-1],2);
	    z_vals[i] = ret[i]/sqrt(lambda_vals[i]);
	}
	
	return(List::create( 
	   _["lambda"]  = lambda_vals, 
	   _["z"] = z_vals
	 ));
}
