
#include <RcppArmadillo.h>
using namespace Rcpp;
using namespace arma;

// [[Rcpp::depends(RcppArmadillo)]]

// [[Rcpp::export]]

List recursive_filter_multi(colvec params, colvec ret, mat rv) 
{
	int T = ret.n_rows;
	int k = rv.n_cols;

	// Rcout << T << " .. " << k << "\n";

	colvec lambda = params.subvec(0,(4+k-1));

	mat phi(4,k);
	for(int i=0;i<4;i++){
		for(int j=0;j<k;j++){
			phi(i, j) = params(4+k+j*4+i);
		}
	}

	colvec lh(T);
	colvec z(T);
	mat u(T, k);
	colvec temp(4);

	for (int i = 0; i<T; i++) {
		if (i==0) {
			lh(0) = params(params.size()-1);
			z(0) = ret(0) / sqrt(exp(lh(0)));
		} else {
			// Hansen specification
			lh(i) = dot(lambda, join_cols(temp, u.row(i-1).t()));
			// lh(i) = dot(lambda, join_cols(temp, log(rv.row(i-1).t())));
			z(i) = ret(i) / sqrt(exp(lh(i)));
		}
		temp(0) = 1;
		temp(1) = lh(i);
		temp(2) = z(i);
		temp(3) = pow(z(i),2)-1;

		for(int j = 0; j<k; j++) {
			u(i, j) = log(rv(i,j)) - dot(phi.col(j), temp);
		}
	}

	return(List::create( 
	   _["lambda"]  = lh, 
	   _["u"]  = u, 
	   _["z"] = z
	 ));
}
